package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;

public class PollRepContent extends ASN1Encodable {
   private DERInteger certReqId;
   private DERInteger checkAfter;
   private PKIFreeText reason;

   private PollRepContent(ASN1Sequence seq) {
      this.certReqId = DERInteger.getInstance(seq.getObjectAt(0));
      this.checkAfter = DERInteger.getInstance(seq.getObjectAt(1));
      if (seq.size() > 2) {
         this.reason = PKIFreeText.getInstance(seq.getObjectAt(2));
      }

   }

   public static PollRepContent getInstance(Object o) {
      if (o instanceof PollRepContent) {
         return (PollRepContent)o;
      } else if (o instanceof ASN1Sequence) {
         return new PollRepContent((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   public DERInteger getCertReqId() {
      return this.certReqId;
   }

   public DERInteger getCheckAfter() {
      return this.checkAfter;
   }

   public PKIFreeText getReason() {
      return this.reason;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.certReqId);
      var10001.add(this.checkAfter);
      PKIFreeText var2;
      if ((var2 = this.reason) != null) {
         var1.add(var2);
      }

      return new DERSequence(var1);
   }
}
